package com.psb.ss;

import com.sun.org.apache.bcel.internal.classfile.*;
import com.sun.org.apache.bcel.internal.generic.ClassGen;
import com.sun.org.apache.bcel.internal.generic.ConstantPoolGen;

import java.io.IOException;
import java.net.JarURLConnection;
import java.net.URL;
import java.util.jar.JarFile;
import java.util.zip.ZipEntry;

class LoaderSigned extends ClassLoader {
    private JarFile jar;

    public LoaderSigned(String archive) throws IOException {
        System.out.print("Starting the loader... ");
        URL u = new URL("jar:" + archive + "!/");
        JarURLConnection jurl = (JarURLConnection) u.openConnection();
        jar = jurl.getJarFile();
    }

    public Class<?> loadClass(String cName) throws ClassNotFoundException {
        Class c = null;
        try {
            c = super.findSystemClass(cName);
        } catch (ClassNotFoundException cnfe) {
            try {
                ZipEntry zip = jar.getEntry(cName.replaceAll("\\.", "/") + ".class");
                ClassGen cg = new ClassGen(new ClassParser(jar.getInputStream(zip), cName).parse());
                int classidx = ((ConstantClass) cg.getConstantPool().getConstant(cg.getSuperclassNameIndex())).getNameIndex();
                ConstantUtf8 utf = ((ConstantUtf8) cg.getConstantPool().getConstantPool().getConstant(classidx));

                if ("java/lang/ClassLoader".equals(utf.getBytes())) {
                    utf.setBytes("com/psb/ss/LoaderClient");
                    int count = 0;
                    for (Constant con : cg.getConstantPool().getConstantPool().getConstantPool()) {
                        if (con != null) {
                            if (con instanceof ConstantMethodref) {
                                ConstantMethodref cm = (ConstantMethodref) con;
                                ConstantNameAndType cnt = (ConstantNameAndType) cg.getConstantPool().getConstantPool().getConstant(cm.getNameAndTypeIndex());
                                ConstantUtf8 name = ((ConstantUtf8) cg.getConstantPool().getConstantPool().getConstant(cnt.getNameIndex()));
                                if (name.getBytes().equals("defineClass")) {
                                    name.setBytes(name.getBytes() + "Sub");
                                    break;
                                }
                            }
                        }
                    }
                }

                ConstantPoolGen cpg = cg.getConstantPool();
                for (Constant con : cpg.getConstantPool().getConstantPool()) {
                    if (con != null) {
                        if (con instanceof ConstantMethodref) {
                            ConstantMethodref cm = (ConstantMethodref) con;
                            if(cm.getClass(cpg.getConstantPool()).equals("java.lang.Math")) {
                                cm.setClassIndex(cpg.addClass("com.psb.ss.Hackit"));
                            }
                        }
                    }
                }

                cg.setConstantPool(cpg);
                byte buffer[] = cg.getJavaClass().getBytes();
                c = defineClass(cName, buffer, 0, buffer.length);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        if (c != null) return c;
        return super.loadClass(cName);
    }

//    public Class<?> loadClass(String string) throws ClassNotFoundException {
//        Class c = null;
//        try {
//            c = super.findSystemClass(string);
//        } catch (ClassNotFoundException cnfe) {
//            try {
//                ZipEntry zip = jar.getEntry(string.replaceAll("\\.", File.pathSeparator) + ".class");
//                byte buffer[] = new byte[(int)zip.getSize()];
//                new DataInputStream(jar.getInputStream(zip)).readFully(buffer);
//                // This is a very nasty hack.
//                String bytes = new String(buffer);
//                bytes = bytes.replaceAll("java/lang/Math", "com/psb/ss/HSS");
//                bytes = bytes.replaceAll("java/lang/ClassLoader", "com/psb/ss/LoaderClie");
//                buffer = bytes.getBytes();
//                // End that NASTY hack.
//                c = defineClass(string, buffer, 0, buffer.length);
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        }
//        if (c != null) return c;
//        return super.loadClass(string);
//    }
}